

// This C++ file was created by SanEditor

#include "Atomic/CleansingModel/CleansingModelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         CleansingModelSAN Constructor             
******************************************************************/


CleansingModelSAN::CleansingModelSAN(){


  Activity* InitialActionList[3]={
    &Restart, //0
    &Interval_1, //1
    &Interval_2  // 2
  };

  BaseGroupClass* InitialGroupList[3]={
    (BaseGroupClass*) &(Interval_1), 
    (BaseGroupClass*) &(Interval_2), 
    (BaseGroupClass*) &(Restart)
  };

  isEnabled = new Place("isEnabled" ,cleansing_enabled);
  CleansingTrigger_ch1 = new Place("CleansingTrigger_ch1" ,0);
  CleansingTrigger_ch2 = new Place("CleansingTrigger_ch2" ,0);
  Cleansing_1 = new Place("Cleansing_1" ,0);
  Cleansing_2 = new Place("Cleansing_2" ,0);
  BaseStateVariableClass* InitialPlaces[5]={
    isEnabled,  // 0
    CleansingTrigger_ch1,  // 1
    CleansingTrigger_ch2,  // 2
    Cleansing_1,  // 3
    Cleansing_2   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("CleansingModel", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        3, InitialActionList, 3, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[8][2]={ 
    {2,0}, {0,0}, {0,1}, {1,1}, {3,1}, {1,2}, {2,2}, {4,2}
  };
  for(int n=0;n<8;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[3][2]={ 
    {2,0}, {0,1}, {1,2}
  };
  for(int n=0;n<3;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<3;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void CleansingModelSAN::CustomInitialization() {

}
CleansingModelSAN::~CleansingModelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void CleansingModelSAN::assignPlacesToActivitiesInst(){
  Restart.CleansingTrigger_ch2 = (Place*) LocalStateVariables[2];
  Restart.isEnabled = (Place*) LocalStateVariables[0];
}
void CleansingModelSAN::assignPlacesToActivitiesTimed(){
  Interval_1.isEnabled = (Place*) LocalStateVariables[0];
  Interval_1.CleansingTrigger_ch1 = (Place*) LocalStateVariables[1];
  Interval_1.Cleansing_1 = (Place*) LocalStateVariables[3];
  Interval_2.CleansingTrigger_ch1 = (Place*) LocalStateVariables[1];
  Interval_2.CleansingTrigger_ch2 = (Place*) LocalStateVariables[2];
  Interval_2.Cleansing_2 = (Place*) LocalStateVariables[4];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================RestartActivity========================*/


CleansingModelSAN::RestartActivity::RestartActivity(){
  ActivityInitialize("Restart",2,Instantaneous , RaceEnabled, 2,1, false);
}

void CleansingModelSAN::RestartActivity::LinkVariables(){
  CleansingTrigger_ch2->Register(&CleansingTrigger_ch2_Mobius_Mark);
  isEnabled->Register(&isEnabled_Mobius_Mark);
}

bool CleansingModelSAN::RestartActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(CleansingTrigger_ch2_Mobius_Mark)) >=1));
  return NewEnabled;
}

double CleansingModelSAN::RestartActivity::Weight(){ 
  return 1;
}

bool CleansingModelSAN::RestartActivity::ReactivationPredicate(){ 
  return false;
}

bool CleansingModelSAN::RestartActivity::ReactivationFunction(){ 
  return false;
}

double CleansingModelSAN::RestartActivity::SampleDistribution(){
  return 0;
}

double* CleansingModelSAN::RestartActivity::ReturnDistributionParameters(){
    return NULL;
}

int CleansingModelSAN::RestartActivity::Rank(){
  return 1;
}

BaseActionClass* CleansingModelSAN::RestartActivity::Fire(){
  (*(CleansingTrigger_ch2_Mobius_Mark))--;
  (*(isEnabled_Mobius_Mark))++;
  return this;
}

/*======================Interval_1Activity========================*/

CleansingModelSAN::Interval_1Activity::Interval_1Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Interval_1",0,Deterministic, RaceEnabled, 3,1, false);
}

CleansingModelSAN::Interval_1Activity::~Interval_1Activity(){
  delete[] TheDistributionParameters;
}

void CleansingModelSAN::Interval_1Activity::LinkVariables(){
  isEnabled->Register(&isEnabled_Mobius_Mark);
  CleansingTrigger_ch1->Register(&CleansingTrigger_ch1_Mobius_Mark);
  Cleansing_1->Register(&Cleansing_1_Mobius_Mark);
}

bool CleansingModelSAN::Interval_1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(isEnabled_Mobius_Mark)) >=1));
  return NewEnabled;
}

double CleansingModelSAN::Interval_1Activity::DeterministicParamValue(){
  return(cleansing_half_interval);
  return 1.0;  // default rate if none is specified
}

double CleansingModelSAN::Interval_1Activity::Weight(){ 
  return 1;
}

bool CleansingModelSAN::Interval_1Activity::ReactivationPredicate(){ 
  return false;
}

bool CleansingModelSAN::Interval_1Activity::ReactivationFunction(){ 
  return false;
}

double CleansingModelSAN::Interval_1Activity::SampleDistribution(){
  return(cleansing_half_interval);
}

double* CleansingModelSAN::Interval_1Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int CleansingModelSAN::Interval_1Activity::Rank(){
  return 1;
}

BaseActionClass* CleansingModelSAN::Interval_1Activity::Fire(){
  (*(isEnabled_Mobius_Mark))--;
  (*(CleansingTrigger_ch1_Mobius_Mark))++;
  (*(Cleansing_1_Mobius_Mark))++;
  return this;
}

/*======================Interval_2Activity========================*/

CleansingModelSAN::Interval_2Activity::Interval_2Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Interval_2",1,Deterministic, RaceEnabled, 3,1, false);
}

CleansingModelSAN::Interval_2Activity::~Interval_2Activity(){
  delete[] TheDistributionParameters;
}

void CleansingModelSAN::Interval_2Activity::LinkVariables(){
  CleansingTrigger_ch1->Register(&CleansingTrigger_ch1_Mobius_Mark);
  CleansingTrigger_ch2->Register(&CleansingTrigger_ch2_Mobius_Mark);
  Cleansing_2->Register(&Cleansing_2_Mobius_Mark);
}

bool CleansingModelSAN::Interval_2Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(CleansingTrigger_ch1_Mobius_Mark)) >=1));
  return NewEnabled;
}

double CleansingModelSAN::Interval_2Activity::DeterministicParamValue(){
  return(cleansing_half_interval);
  return 1.0;  // default rate if none is specified
}

double CleansingModelSAN::Interval_2Activity::Weight(){ 
  return 1;
}

bool CleansingModelSAN::Interval_2Activity::ReactivationPredicate(){ 
  return false;
}

bool CleansingModelSAN::Interval_2Activity::ReactivationFunction(){ 
  return false;
}

double CleansingModelSAN::Interval_2Activity::SampleDistribution(){
  return(cleansing_half_interval);
}

double* CleansingModelSAN::Interval_2Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int CleansingModelSAN::Interval_2Activity::Rank(){
  return 1;
}

BaseActionClass* CleansingModelSAN::Interval_2Activity::Fire(){
  (*(CleansingTrigger_ch1_Mobius_Mark))--;
  (*(CleansingTrigger_ch2_Mobius_Mark))++;
  (*(Cleansing_2_Mobius_Mark))++;
  return this;
}

