#ifndef _SW_REWARD_PVS_
#define _SW_REWARD_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/SW_channel/SW_channelRJ__Rep1.h"
#include "Composed/SW_channel/SW_channelRJ__Rep2.h"
#include "Composed/SW_channel/SW_channelRJ__CH1_Join.h"
#include "Composed/SW_channel/SW_channelRJ__CH2_Join.h"
#include "Composed/SW_channel/SW_channelRJ.h"
#include "Cpp/Performance_Variables/IntervalOfTime.hpp"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class SW_RewardPV0Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV0Worker();
  ~SW_RewardPV0Worker();
  double Reward_Function();
};

class SW_RewardPV0:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV0Worker *SW_RewardPV0WorkerList;

  SW_RewardPV0(int timeindex=0);
  ~SW_RewardPV0();
  void CreateWorkerList(void);
};

class SW_RewardPV1Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV1Worker();
  ~SW_RewardPV1Worker();
  double Reward_Function();
};

class SW_RewardPV1:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV1Worker *SW_RewardPV1WorkerList;

  SW_RewardPV1(int timeindex=0);
  ~SW_RewardPV1();
  void CreateWorkerList(void);
};

class SW_RewardPV2Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV2Worker();
  ~SW_RewardPV2Worker();
  double Reward_Function();
};

class SW_RewardPV2:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV2Worker *SW_RewardPV2WorkerList;

  SW_RewardPV2(int timeindex=0);
  ~SW_RewardPV2();
  void CreateWorkerList(void);
};

class SW_RewardPV3Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV3Worker();
  ~SW_RewardPV3Worker();
  double Reward_Function();
};

class SW_RewardPV3:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV3Worker *SW_RewardPV3WorkerList;

  SW_RewardPV3(int timeindex=0);
  ~SW_RewardPV3();
  void CreateWorkerList(void);
};

class SW_RewardPV4Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV4Worker();
  ~SW_RewardPV4Worker();
  double Reward_Function();
};

class SW_RewardPV4:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV4Worker *SW_RewardPV4WorkerList;

  SW_RewardPV4(int timeindex=0);
  ~SW_RewardPV4();
  void CreateWorkerList(void);
};

class SW_RewardPV5Worker:public IntervalOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV5Worker();
  ~SW_RewardPV5Worker();
  double Reward_Function();
};

class SW_RewardPV5:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV5Worker *SW_RewardPV5WorkerList;

  SW_RewardPV5(int timeindex=0);
  ~SW_RewardPV5();
  void CreateWorkerList(void);
};

class SW_RewardPV6Worker:public InstantOfTime
{
 public:
  system_stateSAN *system_state1;
  
  SW_RewardPV6Worker();
  ~SW_RewardPV6Worker();
  double Reward_Function();
};

class SW_RewardPV6:public PerformanceVariableNode
{
 public:
  SW_channelRJ *TheSW_channelRJ;

  SW_RewardPV6Worker *SW_RewardPV6WorkerList;

  SW_RewardPV6(int timeindex=0);
  ~SW_RewardPV6();
  void CreateWorkerList(void);
};

#endif
