
#ifndef study_2SetSTUDY_H_
#define study_2SetSTUDY_H_

#include "Reward/SW_Reward/SW_RewardPVNodes.h"
#include "Reward/SW_Reward/SW_RewardPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern double FR_increment;
extern double FR_init_pfd;
extern double FR_other_pfd;
extern double attackRateIncrement;
extern double attack_success_prob_reduction;
extern double ch1_init_pfd;
extern double ch2_init_pfd;
extern short cleansing_enabled;
extern double cleansing_half_interval;
extern double common_pfd;
extern double compromise_detection_prob;
extern double delay_sync_attack;
extern double demand_default_rate;
extern double demand_rate_0_0;
extern double demand_rate_0_1;
extern double demand_rate_0_2;
extern double demand_rate_0_3;
extern double demand_rate_0_4;
extern double demand_rate_0_default;
extern double demand_rate_1_0;
extern double demand_rate_1_1;
extern double demand_rate_1_2;
extern double demand_rate_1_3;
extern double demand_rate_1_4;
extern double demand_rate_1_default;
extern short demand_types_ch1;
extern short demand_types_ch2;
extern short demand_types_max;
extern double evolutionInterval;
extern short evolution_enabled;
extern short isAttackListTheSame;
extern short isPatchingDelayed;
extern short malicious_demand_max_FRs;
extern double normal_demands_intervals;
extern double patchingInterval;
extern double patching_channel_pfd_reduction;
extern double patching_common_pfd_reduction;
extern short patching_enabled;
extern int patching_model;
extern short time_sync_enabled;
extern double upgrade_duration;

class study_2SetStudy : public BaseStudyClass {
public:

study_2SetStudy();
~study_2SetStudy();

private:

double *FR_incrementValues;
double *FR_init_pfdValues;
double *FR_other_pfdValues;
double *attackRateIncrementValues;
double *attack_success_prob_reductionValues;
double *ch1_init_pfdValues;
double *ch2_init_pfdValues;
short *cleansing_enabledValues;
double *cleansing_half_intervalValues;
double *common_pfdValues;
double *compromise_detection_probValues;
double *delay_sync_attackValues;
double *demand_default_rateValues;
double *demand_rate_0_0Values;
double *demand_rate_0_1Values;
double *demand_rate_0_2Values;
double *demand_rate_0_3Values;
double *demand_rate_0_4Values;
double *demand_rate_0_defaultValues;
double *demand_rate_1_0Values;
double *demand_rate_1_1Values;
double *demand_rate_1_2Values;
double *demand_rate_1_3Values;
double *demand_rate_1_4Values;
double *demand_rate_1_defaultValues;
short *demand_types_ch1Values;
short *demand_types_ch2Values;
short *demand_types_maxValues;
double *evolutionIntervalValues;
short *evolution_enabledValues;
short *isAttackListTheSameValues;
short *isPatchingDelayedValues;
short *malicious_demand_max_FRsValues;
double *normal_demands_intervalsValues;
double *patchingIntervalValues;
double *patching_channel_pfd_reductionValues;
double *patching_common_pfd_reductionValues;
short *patching_enabledValues;
int *patching_modelValues;
short *time_sync_enabledValues;
double *upgrade_durationValues;

void SetValues_FR_increment();
void SetValues_FR_init_pfd();
void SetValues_FR_other_pfd();
void SetValues_attackRateIncrement();
void SetValues_attack_success_prob_reduction();
void SetValues_ch1_init_pfd();
void SetValues_ch2_init_pfd();
void SetValues_cleansing_enabled();
void SetValues_cleansing_half_interval();
void SetValues_common_pfd();
void SetValues_compromise_detection_prob();
void SetValues_delay_sync_attack();
void SetValues_demand_default_rate();
void SetValues_demand_rate_0_0();
void SetValues_demand_rate_0_1();
void SetValues_demand_rate_0_2();
void SetValues_demand_rate_0_3();
void SetValues_demand_rate_0_4();
void SetValues_demand_rate_0_default();
void SetValues_demand_rate_1_0();
void SetValues_demand_rate_1_1();
void SetValues_demand_rate_1_2();
void SetValues_demand_rate_1_3();
void SetValues_demand_rate_1_4();
void SetValues_demand_rate_1_default();
void SetValues_demand_types_ch1();
void SetValues_demand_types_ch2();
void SetValues_demand_types_max();
void SetValues_evolutionInterval();
void SetValues_evolution_enabled();
void SetValues_isAttackListTheSame();
void SetValues_isPatchingDelayed();
void SetValues_malicious_demand_max_FRs();
void SetValues_normal_demands_intervals();
void SetValues_patchingInterval();
void SetValues_patching_channel_pfd_reduction();
void SetValues_patching_common_pfd_reduction();
void SetValues_patching_enabled();
void SetValues_patching_model();
void SetValues_time_sync_enabled();
void SetValues_upgrade_duration();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

